_ENV = AIContext

function damaged_ship(ship)
  local max_structure = 0.7*ship.structure

  return saturate( ( (ship.armor_damage or 0 ) + (ship.structure_damage or 0) ) / (ship.armor + max_structure) )
end

local get_ship_design = weak_memoizeNN | function(ship)
  return Design.clone(ship.source_design)
end

function ship_power_score(ship)
  local design = get_ship_design | ship
  local combat_power = design_combat_value(design)

  if ship.empire == empire
    combat_power *= 1 - damaged_ship(ship)
  end


  return combat_power
end

